# $Revision: 1.81 $, $Date: 2003/12/26 13:18:37 $
#
# Conditional build:
# alternative busybox config file (replaces default one) you should
# define cfgfile macro, i.e.
#
#       rpm --rebuild busybox.*.src.rpm --with altconfig --define "cfgfile bb-emb-config.h"
%bcond_with	altconfig	# use alternative config (defined by cfgfile)
%bcond_with	linkfl		# creates links to busybox binary and puts them into file list
# Options below are useful, when you want fileutils and grep providing.
# For example, ash package requires fileutils and grep.
%bcond_with	fileutl_prov	# adds fileutils providing
%bcond_with	grep_prov	# adds grep providing
# Option below is useful, when busybox is built with shell support.
%bcond_with	sh_prov		# adds /bin/sh providing
# WARNING! Shell, filetuils and grep providing may depend on config file!
# Fileutils, grep and shell provided with busybox have not such
# functionality as their GNU countenders.
#
%bcond_without	static		# don't build static version
%bcond_without	initrd		# don't build initrd version
%bcond_with	dietlibc	# build dietlibc-based initrd version
%bcond_with	glibc		# build glibc-based initrd version
#
%ifnarch %{ix86}
%define with_glibc 1
%endif
Summary:	Set of common unix utils for embeded systems
Summary(pl):	Zestaw narzdzi uniksowych dla systemw wbudowanych
Summary(pt_BR):	BusyBox  um conjunto de utilitrios UNIX em um nico binrio
Name:		busybox
Version:	1.00
%define	pre	pre5
Release:	0.%{pre}.1
License:	GPL
Group:		Applications
Source0:	http://www.busybox.net/downloads/%{name}-%{version}-%{pre}.tar.bz2
# Source0-md5:	f89d08842d0a48c73ba4ef1e3c3bdb8b
Source1:	%{name}.config
Source2:	%{name}-initrd.config
%{?with_altconfig:Source3:	%{cfgfile}}
Patch0:		%{name}-logconsole.patch
Patch1:		%{name}-print_ascii.patch
Patch2:		%{name}-printf-gettext.patch
Patch3:		%{name}-loadfont.patch
Patch4:		%{name}-pivot_root.patch
Patch5:		%{name}-malloc.patch
Patch6:		%{name}-raid_start.patch
Patch8:		%{name}-force-dietlibc.patch
Patch9:		%{name}-ash_exec.patch
Patch10:	%{name}-amd64.patch
Patch11:	%{name}-kernel_headers.patch
Patch12:	%{name}-insmod-morearchs.patch
URL:		http://www.busybox.net/
%{?with_static:BuildRequires:	glibc-static}
%if %{with initrd}
  %if %{with dietlibc}
BuildRequires:	dietlibc-static
  %else
    %if %{with glibc}
BuildRequires:	glibc-static
    %else
BuildRequires:	uClibc-static >= 0.9.21
    %endif
  %endif
%endif
%{?with_fileutl_prov:Provides:	fileutils}
%{?with_grep_prov:Provides:	grep}
%{?with_sh_prov:Provides:	/bin/sh}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_initrd_bindir	/bin

%description
BusyBox combines tiny versions of many common UNIX utilities into a
single small executable. It provides minimalist replacements for most
of the utilities you usually find in fileutils, shellutils, findutils,
textutils, grep, gzip, tar, etc. BusyBox provides a fairly complete
POSIX environment for any small or embedded system. The utilities in
BusyBox generally have fewer options than their full-featured GNU
cousins; however, the options that are included provide the expected
functionality and behave very much like their GNU counterparts.

BusyBox has been written with size-optimization and limited resources
in mind. It is also extremely modular so you can easily include or
exclude commands (or features) at compile time. This makes it easy to
customize your embedded systems. To create a working system, just add
a kernel, a shell (such as ash), and an editor (such as elvis-tiny or
ae).

%description -l pl
BusyBox skada mae wersje wielu narzdzi uniksowych w jeden may plik
wykonywalny. Zapewnia minimalne zastpniki wikszoci narzdzi
zawartych w pakietach fileutils, shellutils, findutils, grep, gzip,
tar itp. BusyBox daje w miar kompletne rodowisko POSIX dla maych
lub wbudowanych systemw. Narzdzia maj mniej opcji ni ich pene
odpowiedniki GNU, ale maj podstawow funkcjonalno. Do dziaajcego
systemu potrzeba jeszcze tylko kernela, shella (np. ash) oraz edytora
(np. elvis-tiny albo ae).

%description -l pt_BR
BusyBox combina verses reduzidas de muitos utilitrios UNIX num nico
executvel, fornecendo substitutos minimalistas para muitos dos
executveis encontrados em pacotes como fileutils, shellutils,
findutils, textutils, grep, gzip, tar, etc. Os utilitrios do BusyBox
em geral tm menos opes que os utilitrios GNU, mas as opes
implementadas comportam-se de maneira similar aos equivalentes GNU.

%package static
Summary:	Static busybox
Summary(pl):	Statycznie skonsolidowany busybox
Group:		Applications

%description static
Static busybox.

%description static -l pl
Statycznie skonsolidowany busybox.

%package initrd
Summary:	Static busybox for initrd
Summary(pl):	Statycznie skonsolidowany busybox dla initrd
Group:		Applications
Conflicts:	geninitrd < 3075

%description initrd
Static busybox for initrd.

%description initrd -l pl
Statycznie skonsolidowany busybox dla initrd.

%prep
%setup -q -n %{name}-%{version}-%{pre}
%patch0 -p1
%patch1 -p1
#X %patch2 -p1 // UPDATE ME
%patch3 -p1
%patch4 -p1
#%patch5 -p1 // not needed
%patch6 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1

%build
install %{SOURCE1} .config

%if %{with initrd}
install %{SOURCE2} .config
%{__make} oldconfig
%{__make} \
	CFLAGS_EXTRA="%{rpmcflags} -D_BSD_SOURCE" \
	LDFLAGS="%{rpmldflags} -static" \
%if %{with dietlibc}
	LIBRARIES="-lrpc" \
	CC="diet gcc"
%else
%if %{with glibc}
	CC="%{__cc}"
%else
	CC="%{_target_cpu}-uclibc-gcc"
%endif
%endif

mv -f busybox busybox.initrd
%{__make} clean
install %{SOURCE1} .config
%endif

%if %{with altconfig}
install %{SOURCE3} .config
%endif

%if %{with static}
%{__make} oldconfig
%{__make}  \
	CFLAGS_EXTRA="%{rpmcflags}" \
	LDFLAGS="%{rpmldflags} -static" \
	CC="%{__cc}"
mv -f busybox busybox.static
%{__make} clean
%endif

%{__make} oldconfig
%{__make} \
	CFLAGS_EXTRA="%{rpmcflags}" \
	LDFLAGS="%{rpmldflags}" \
	CC="%{__cc}"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_initrd_bindir},%{_bindir},%{_mandir}/man1,%{_libdir}/busybox}

%{?with_static:install busybox.static $RPM_BUILD_ROOT%{_bindir}}
%{?with_initrd:install busybox.initrd $RPM_BUILD_ROOT%{_initrd_bindir}/initrd-busybox}

install busybox.links $RPM_BUILD_ROOT%{_libdir}/busybox
install docs/BusyBox.1 $RPM_BUILD_ROOT%{_mandir}/man1
echo ".so BusyBox.1" > $RPM_BUILD_ROOT%{_mandir}/man1/busybox.1

# install links to busybox binary, when linkfl is defined
%if %{with linkfl}
%{__make} install \
	PREFIX=$RPM_BUILD_ROOT
%else
install busybox $RPM_BUILD_ROOT%{_bindir}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS TODO Changelog README .config

%if %{with linkfl}
%attr(755,root,root) /bin/*
%attr(755,root,root) /sbin/*
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_sbindir}/*
%else
%attr(755,root,root) %{_bindir}/busybox
%endif

%{_libdir}/busybox
%{_mandir}/man1/*

%if %{with static}
%files static
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/busybox.static
%endif

%if %{with initrd}
%files initrd
%defattr(644,root,root,755)
%attr(755,root,root) %{_initrd_bindir}/initrd-busybox
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: busybox.spec,v $
Revision 1.81  2003/12/26 13:18:37  qboosh
- added insmod-morearchs patch with defines for alpha and possibly sparc
- some cleanups

Revision 1.80  2003/12/25 19:23:00  arekm
- added conflicts

Revision 1.79  2003/12/25 19:00:31  arekm
- updated to pre5

Revision 1.78  2003/12/21 17:22:10  jajcus
- compilation with userspace kernel headers fixed (-kernel_headers.patch)

Revision 1.77  2003/12/21 15:34:24  arekm
- add initial support for amd64

Revision 1.76  2003/12/11 14:15:10  areq
- add print_ascii.patch

Revision 1.75  2003/12/11 09:42:32  areq
- start update to pre4

Revision 1.74  2003/10/25 13:25:41  ankry
- pl: linkowanie -> konsolidacja, shell -> powoka

Revision 1.73  2003/09/19 13:20:57  arekm
- BR: uClibc-static >= 0.9.21 (initrd-busybox segfaults with older versions)

Revision 1.72  2003/09/15 19:05:12  arekm
- fix insmod_ng (was broken in previous release of pre3)

Revision 1.71  2003/09/12 21:49:36  areq
- remove outdated insmod-gpl.patch

Revision 1.70  2003/09/12 20:02:28  areq
- start update to pre3

Revision 1.69  2003/09/03 15:14:39  qboosh
- typo, use just ifnarch

Revision 1.68  2003/09/03 15:12:11  malekith
- added --with glibc to compile initrd version with regular glibc-static
  (to be used on non x86 platforms, since there are severe problems with
   x86-centric uClibc)
- release .8

Revision 1.67  2003/08/24 20:55:27  blues
- renumbered patches

Revision 1.66  2003/08/24 10:50:43  malekith
- patch ash_exec: don't bailout when there's only /bin/sh, not /bin/busybox
- release .7

Revision 1.65  2003/08/24 10:37:36  malekith
- remove -config.patches (not used)

Revision 1.64  2003/08/18 08:07:56  gotar
- mass commit: cosmetics (removed trailing white spaces)

Revision 1.63  2003/08/15 21:45:25  malekith
- fixed raid_start to allow more then one device
- release 0.pre.6

Revision 1.62  2003/08/07 19:56:42  arekm
- rename initrd busybox binary

Revision 1.61  2003/08/07 11:00:27  blues
- reverted last change (really no other better way??)

Revision 1.60  2003/08/06 21:53:03  blues
- cosmetics

Revision 1.59  2003/08/06 16:39:12  kloczek
- moe wrescie kto wykasuje to konto ?

Revision 1.58  2003/08/05 21:42:36  arekm
- added support for loading GPL_ modules

Revision 1.57  2003/08/03 10:45:44  arekm
- move busybox.initrd to /bin

Revision 1.56  2003/08/02 23:49:08  arekm
- switch to uClibc but leave dietlibc in bcond

Revision 1.55  2003/08/02 22:52:46  arekm
- updated to 1.0.0pre2.
  TODO:
    - fix patch nr 3
    - fix default config and create minimal config for initrd version
    - check compilation with dietlibc and uClibc

Revision 1.54  2003/07/01 01:21:57  malekith
- added insmod_ng patch with 2.5 kernel support
- can be also called as insmod, when 2.5 kernel is detetected -- insmod_ng
  is run

Revision 1.53  2003/07/01 00:02:35  malekith
- reorder patches; config patches get high numbers
- add raid_start support

Revision 1.52  2003/06/30 23:06:35  malekith
- store configuration in patch, don't overwrite original file

Revision 1.51  2003/06/30 22:56:05  malekith
- added initrd subpackage (busybox linked against dietlibc as bsp
  replacement)
- release 2

Revision 1.50  2003/06/30 22:25:24  malekith
- remove not needed cread and child patches
- still not sure about malloc though

Revision 1.49  2003/06/30 22:10:22  malekith
- new style bconds

Revision 1.48  2003/05/28 12:58:47  malekith
- massive attack: source-md5

Revision 1.47  2003/05/25 05:46:05  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.46  2002/10/27 11:48:14  areq
- 0.60.5
- update logconsole.patch
- update URL, link SOURCE, switch to bz2
- comment patch 5,6,8 - outdated ?

Revision 1.45  2002/10/10 12:26:29  marcus
- use new %%doc

Revision 1.44  2002/07/29 11:59:18  malekith
- added child.patch so busybox init will take over orphaned processes
  thus preventing zilions of Z processes on bootdisk
- release 8

Revision 1.43  2002/05/16 20:02:40  qboosh
- added Config.h to doc (may be useful - to know what capabilities are set)

Revision 1.42  2002/05/10 12:57:09  wrobell
- do not install busybox binary twice when using linkfl option
- rel. 7

Revision 1.41  2002/05/10 12:17:10  wrobell
- added new options:
  - altconfig     - build busybox with alternative busybox config file
  - linkfl        - creates links to busybox binary and includes them into filelist
  - fileutil_prov - adds fileutils providing
  - grep_prov     - adds grep providing
  - sh_prov       - adds /bin/sh providing
- rel. 6

Revision 1.40  2002/04/25 15:56:05  arturs
fixed a small typo

Revision 1.39  2002/04/25 09:06:54  kloczek
- updated to 0.60.2 (release 5).

Revision 1.38  2002/04/25 08:39:04  kloczek
- merge translations from Conectiva.

Revision 1.37  2002/03/08 14:35:09  malekith
- pass CC to make

Revision 1.36  2002/03/05 18:09:01  marcus
- remove uclibc stuff
- rel.17.

Revision 1.35  2002/02/23 01:33:37  kloczek
- adapterized.

Revision 1.34  2002/02/22 23:28:44  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.33  2002/01/21 18:15:46  malekith
- BOOT -> embed
- rel 16

Revision 1.32  2002/01/18 02:12:32  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.31  2002/01/17 13:28:59  qboosh
- removed obsolete TODO comment

Revision 1.30  2002/01/17 13:26:51  qboosh
- release 15: added -static subpackage

Revision 1.29  2001/10/29 19:14:40  malekith
- rel 14
- new version of malloc patch and new pivot_root patch

Revision 1.28  2001/09/07 23:33:00  klakier
- removed sh_name.patch

Revision 1.27  2001/09/07 23:19:12  klakier
- config changed: disables ash, vi, enables lash
  Reasons:
  1) busybox ash makes trouble (crashes on some scripts) and is
     horribly slow
  2) _extremely_ small vi applet is provided by e3 package
  3) lash is poor bu it has some nice interactive features (completion, history)

  Please do not introduce substantial changes to this package without
  testing the results before! If you really need changes please consult them
  on one of pld mailing lists!!!

Revision 1.26  2001/08/30 22:42:48  filon
- updated to 0.60.1 (modified patches)
- there are much more applets (ash, vi, ..)
- it's smaller than ever before
- added ash to config, it's much smaller than ash-BOOT

Revision 1.25  2001/08/28 12:13:24  wiget
fix BOOT subpackage
release 12

Revision 1.24  2001/08/19 15:47:05  kloczek
- remove -s from LDFLAGS.

Revision 1.23  2001/08/18 11:03:00  malekith
- fixed, now builds correctly

Revision 1.22  2001/08/18 09:41:38  malekith
- fixes insmod problems with 3c boomerang
- rel 11

Revision 1.21  2001/08/09 16:37:24  qboosh
- base package is dynamically linked and has pl summary/description
- fixed BOOT bcond

Revision 1.20  2001/08/01 12:36:44  malekith
- enabled nc (netcat)

Revision 1.19  2001/07/30 15:51:56  klakier
- rel 9
- syslogd and klogd added to Config.h

Revision 1.18  2001/07/05 10:35:41  kloczek
- BuildRequires for uClibc-devel-BOOT only when %%{BOOT is defined.

Revision 1.17  2001/07/05 08:49:06  wiget
added pivot_root and freeramdisk; release 8

Revision 1.16  2001/06/13 09:23:30  malekith
- rel 7
- added cread patch (can anybody check if it works?)

Revision 1.15  2001/06/12 13:25:51  klakier
- rel 6
- loadfont added to config
- added loadfont.patch to be able to load lat2-16 font
  (THIS PATCH IS VERY NASTY HACK, but works)

Revision 1.14  2001/05/31 15:14:26  malekith
- added printf-gettext batch by /me
- rel 5

Revision 1.13  2001/05/22 22:51:05  klakier
- added -m386 for BOOT

Revision 1.12  2001/05/21 19:02:36  klakier
- rel 4
- compiled against uClibc 20010521

Revision 1.11  2001/05/21 11:41:41  klakier
- fixed broken 'cosmetics' from rev 1.9. Please DO NOT make
  substantial changes in %build or %install without testing it

Revision 1.10  2001/05/20 10:53:48  klakier
- rel 3 (fixed sh_name.patch)

Revision 1.9  2001/05/20 10:16:18  kloczek
- cosmetics.

Revision 1.8  2001/05/19 11:20:40  klakier
- added sh_name patch and change /bin/sh to /bin/lash (sh is in ash-BOOT)

Revision 1.7  2001/05/16 15:14:05  klakier
- changes

Revision 1.6  2001/04/24 04:42:17  kloczek
- release 2.

Revision 1.5  2001/04/13 13:56:14  klakier
- added BOOT package
- linked statically against uClibc

Revision 1.4  2001/04/11 22:26:33  kloczek
- removed outdated 0.50 patch.

Revision 1.3  2001/04/11 20:37:46  areq
- 0.51
- comment busybox-0.50.patch

Revision 1.2  2001/04/04 18:09:00  kloczek
- added more %description,
- added full Source url,
- move busybox executable to %%{_bindir},
- added man page for busybox,
- some style fixes in %install.

Revision 1.1  2001/04/03 17:06:40  malekith
from scratch.
